// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// A pipeline activity.
    /// </summary>
    public abstract partial class BaseActivity
    {
        private string _description;
        
        /// <summary>
        /// Optional. Activity description.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private IList<ActivityInput> _inputs;
        
        /// <summary>
        /// Optional. Inputs.
        /// </summary>
        public IList<ActivityInput> Inputs
        {
            get { return this._inputs; }
            set { this._inputs = value; }
        }
        
        private string _linkedServiceName;
        
        /// <summary>
        /// Optional. LinkedService name where the Activity Runs.
        /// </summary>
        public string LinkedServiceName
        {
            get { return this._linkedServiceName; }
            set { this._linkedServiceName = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Activity name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private IList<ActivityOutput> _outputs;
        
        /// <summary>
        /// Optional. Outputs.
        /// </summary>
        public IList<ActivityOutput> Outputs
        {
            get { return this._outputs; }
            set { this._outputs = value; }
        }
        
        private ActivityPolicy _policy;
        
        /// <summary>
        /// Optional. Policy.
        /// </summary>
        public ActivityPolicy Policy
        {
            get { return this._policy; }
            set { this._policy = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BaseActivity class.
        /// </summary>
        public BaseActivity()
        {
            this.Inputs = new LazyList<ActivityInput>();
            this.Outputs = new LazyList<ActivityOutput>();
        }
        
        /// <summary>
        /// Initializes a new instance of the BaseActivity class with required
        /// arguments.
        /// </summary>
        public BaseActivity(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
