// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// Parameters for a Stream Analytics output list operation.
    /// </summary>
    public partial class OutputListParameters
    {
        private string _propertiesToSelect;
        
        /// <summary>
        /// Required. Gets or sets the properties to select. Comma-separated
        /// list of structural properties to include in the response, or “*”
        /// to include all properties. By default, all properties are returned
        /// except diagnostics.
        /// </summary>
        public string PropertiesToSelect
        {
            get { return this._propertiesToSelect; }
            set { this._propertiesToSelect = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OutputListParameters class.
        /// </summary>
        public OutputListParameters()
        {
            this.PropertiesToSelect = "";
        }
        
        /// <summary>
        /// Initializes a new instance of the OutputListParameters class with
        /// required arguments.
        /// </summary>
        public OutputListParameters(string propertiesToSelect)
            : this()
        {
            if (propertiesToSelect == null)
            {
                throw new ArgumentNullException("propertiesToSelect");
            }
            this.PropertiesToSelect = propertiesToSelect;
        }
    }
}
