// Code generated by Microsoft (R) AutoRest Code Generator 0.12.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// AutoHealActions - Describes the actions which can be
    /// taken by the auto-heal module when a rule is triggered.
    /// </summary>
    public partial class AutoHealActions
    {
        /// <summary>
        /// Initializes a new instance of the AutoHealActions class.
        /// </summary>
        public AutoHealActions() { }

        /// <summary>
        /// Initializes a new instance of the AutoHealActions class.
        /// </summary>
        public AutoHealActions(AutoHealActionType? actionType, AutoHealCustomAction customAction = default(AutoHealCustomAction), string minProcessExecutionTime = default(string))
        {
            ActionType = actionType;
            CustomAction = customAction;
            MinProcessExecutionTime = minProcessExecutionTime;
        }

        /// <summary>
        /// ActionType - predefined action to be taken. Possible values for
        /// this property include: 'Recycle', 'LogEvent', 'CustomAction'.
        /// </summary>
        [JsonProperty(PropertyName = "actionType")]
        public AutoHealActionType? ActionType { get; set; }

        /// <summary>
        /// CustomAction - custom action to be taken
        /// </summary>
        [JsonProperty(PropertyName = "customAction")]
        public AutoHealCustomAction CustomAction { get; set; }

        /// <summary>
        /// MinProcessExecutionTime - minimum time the process must execute
        /// before taking the action
        /// </summary>
        [JsonProperty(PropertyName = "minProcessExecutionTime")]
        public string MinProcessExecutionTime { get; set; }

        /// <summary>
        /// Validate the object. Throws ArgumentException or ArgumentNullException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (ActionType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ActionType");
            }
        }
    }
}
