// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Objects that provide input endpoint details.
    /// </summary>
    public partial class InputEndpoint
    {
        private bool? _enableDirectServerReturn;
        
        /// <summary>
        /// Optional. Specifies whether direct server return is enabled for the
        /// endpoint.
        /// </summary>
        public bool? EnableDirectServerReturn
        {
            get { return this._enableDirectServerReturn; }
            set { this._enableDirectServerReturn = value; }
        }
        
        private EndpointAcl _endpointAcl;
        
        /// <summary>
        /// Optional. Specifies the list of access control rules for the
        /// endpoint.
        /// </summary>
        public EndpointAcl EndpointAcl
        {
            get { return this._endpointAcl; }
            set { this._endpointAcl = value; }
        }
        
        private int? _idleTimeoutInMinutes;
        
        /// <summary>
        /// Optional. The idle timeout in minutes for this endpoint.
        /// </summary>
        public int? IdleTimeoutInMinutes
        {
            get { return this._idleTimeoutInMinutes; }
            set { this._idleTimeoutInMinutes = value; }
        }
        
        private string _loadBalancedEndpointSetName;
        
        /// <summary>
        /// Optional. Specifies a name for a set of load-balanced endpoints.
        /// Specifying this name in multiple endpoints adds them all to the
        /// set. This element is only listed for Virtual Machine deployments.
        /// </summary>
        public string LoadBalancedEndpointSetName
        {
            get { return this._loadBalancedEndpointSetName; }
            set { this._loadBalancedEndpointSetName = value; }
        }
        
        private string _loadBalancerDistribution;
        
        /// <summary>
        /// Optional. Load Balancer Distribution for this endpoint.
        /// </summary>
        public string LoadBalancerDistribution
        {
            get { return this._loadBalancerDistribution; }
            set { this._loadBalancerDistribution = value; }
        }
        
        private string _loadBalancerName;
        
        /// <summary>
        /// Optional. Optional. Specify the name of an internal load balancer
        /// if this endpoint shall not be exposed on the default load balancer.
        /// </summary>
        public string LoadBalancerName
        {
            get { return this._loadBalancerName; }
            set { this._loadBalancerName = value; }
        }
        
        private LoadBalancerProbe _loadBalancerProbe;
        
        /// <summary>
        /// Optional. Contains properties that specify the endpoint settings
        /// which the Azure load balancer uses to monitor the availability of
        /// this virtual machine before forwarding traffic to the endpoint.
        /// </summary>
        public LoadBalancerProbe LoadBalancerProbe
        {
            get { return this._loadBalancerProbe; }
            set { this._loadBalancerProbe = value; }
        }
        
        private int? _localPort;
        
        /// <summary>
        /// Optional. Specifies the internal port on which the virtual machine
        /// is listening to serve the endpoint. This element is only listed
        /// for Virtual Machine deployments.
        /// </summary>
        public int? LocalPort
        {
            get { return this._localPort; }
            set { this._localPort = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Specifies the name for the external endpoint. This
        /// element is only listed for Virtual Machine deployments.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private int? _port;
        
        /// <summary>
        /// Optional. The size of the role instance.
        /// </summary>
        public int? Port
        {
            get { return this._port; }
            set { this._port = value; }
        }
        
        private string _protocol;
        
        /// <summary>
        /// Optional. Specifies the transport protocol for the endpoint.
        /// </summary>
        public string Protocol
        {
            get { return this._protocol; }
            set { this._protocol = value; }
        }
        
        private string _virtualIPAddress;
        
        /// <summary>
        /// Optional. The virtual IP address of the role instance.
        /// </summary>
        public string VirtualIPAddress
        {
            get { return this._virtualIPAddress; }
            set { this._virtualIPAddress = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the InputEndpoint class.
        /// </summary>
        public InputEndpoint()
        {
        }
    }
}
