// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.ExpressRoute.Models;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Update Cross Connection Operation Parameters.
    /// </summary>
    public partial class CrossConnectionUpdateParameters
    {
        private UpdateCrossConnectionOperation _operation;
        
        /// <summary>
        /// Optional. Specifies the notification operation to perform. Possible
        /// values are: NotifyCrossConnectionProvisioned,
        /// NotifyCrossConnectionNotProvisioned.
        /// </summary>
        public UpdateCrossConnectionOperation Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private string _provisioningError;
        
        /// <summary>
        /// Optional. Specifies the error that occurred if provisioning was not
        /// successful.
        /// </summary>
        public string ProvisioningError
        {
            get { return this._provisioningError; }
            set { this._provisioningError = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CrossConnectionUpdateParameters
        /// class.
        /// </summary>
        public CrossConnectionUpdateParameters()
        {
        }
    }
}
