// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Sql.Models;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Contains the response from a request to List Firewall Rules.
    /// </summary>
    public partial class FirewallRuleListResponse : AzureOperationResponse, IEnumerable<FirewallRule>
    {
        private IList<FirewallRule> _firewallRules;
        
        /// <summary>
        /// Optional. Gets the collection of firewall rules returned from the
        /// List Firewall Rules operation.
        /// </summary>
        public IList<FirewallRule> FirewallRules
        {
            get { return this._firewallRules; }
            set { this._firewallRules = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the FirewallRuleListResponse class.
        /// </summary>
        public FirewallRuleListResponse()
        {
            this.FirewallRules = new LazyList<FirewallRule>();
        }
        
        /// <summary>
        /// Gets the sequence of FirewallRules.
        /// </summary>
        public IEnumerator<FirewallRule> GetEnumerator()
        {
            return this.FirewallRules.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of FirewallRules.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
