// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// The response returned from the Create Server operation.  This contains
    /// all the information returned from the service when a server is created.
    /// </summary>
    public partial class ServerCreateResponse : AzureOperationResponse
    {
        private string _fullyQualifiedDomainName;
        
        /// <summary>
        /// Optional. Gets the fully qualified domain name of the server.
        /// </summary>
        public string FullyQualifiedDomainName
        {
            get { return this._fullyQualifiedDomainName; }
            set { this._fullyQualifiedDomainName = value; }
        }
        
        private string _serverName;
        
        /// <summary>
        /// Optional. Gets the name of the Azure SQL Database Server that was
        /// provisioned.
        /// </summary>
        public string ServerName
        {
            get { return this._serverName; }
            set { this._serverName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServerCreateResponse class.
        /// </summary>
        public ServerCreateResponse()
        {
        }
    }
}
