// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// IscsiConnection Details
    /// </summary>
    public partial class IscsiConnection
    {
        private string _acrInstanceId;
        
        /// <summary>
        /// Required. Gets or sets the Acr instance identifier
        /// </summary>
        public string AcrInstanceId
        {
            get { return this._acrInstanceId; }
            set { this._acrInstanceId = value; }
        }
        
        private string _acrName;
        
        /// <summary>
        /// Required. Gets or sets the Acr name
        /// </summary>
        public string AcrName
        {
            get { return this._acrName; }
            set { this._acrName = value; }
        }
        
        private IList<string> _allowedVolumeNames;
        
        /// <summary>
        /// Required. Gets or sets the allowed volume names
        /// </summary>
        public IList<string> AllowedVolumeNames
        {
            get { return this._allowedVolumeNames; }
            set { this._allowedVolumeNames = value; }
        }
        
        private string _initiatorAddress;
        
        /// <summary>
        /// Required. Gets or sets the Initiator address
        /// </summary>
        public string InitiatorAddress
        {
            get { return this._initiatorAddress; }
            set { this._initiatorAddress = value; }
        }
        
        private string _iqn;
        
        /// <summary>
        /// Required. Gets or sets the IQN
        /// </summary>
        public string Iqn
        {
            get { return this._iqn; }
            set { this._iqn = value; }
        }
        
        private string _iscsiConnectionId;
        
        /// <summary>
        /// Required. Gets or sets the Iscsi instance identifier
        /// </summary>
        public string IscsiConnectionId
        {
            get { return this._iscsiConnectionId; }
            set { this._iscsiConnectionId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the IscsiConnection class.
        /// </summary>
        public IscsiConnection()
        {
            this.AllowedVolumeNames = new List<string>();
        }
    }
}
