// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Volume container confirmation status
    /// </summary>
    public enum MigrationDataContainerConfirmStatus
    {
        /// <summary>
        /// Status indicates that the volume container migration has not started
        /// </summary>
        MigrationNotStarted = 0,
        
        /// <summary>
        /// Status indicates that the migration of volume container is in
        /// progress
        /// </summary>
        MigrationInProgress = 1,
        
        /// <summary>
        /// Status indicates that the migration of volume container has
        /// completed
        /// </summary>
        MigrationComplete = 2,
        
        /// <summary>
        /// Status indicates that the migration of volume container has failed
        /// </summary>
        MigrationFailed = 3,
        
        /// <summary>
        /// Status indicates that the commit of migrated volume container is in
        /// progress
        /// </summary>
        CommitInProgress = 4,
        
        /// <summary>
        /// Status indicates that the migrated volume container has
        /// successfully commited
        /// </summary>
        CommitComplete = 5,
        
        /// <summary>
        /// Status indicates that the commit of migrated volume container has
        /// failed
        /// </summary>
        CommitFailed = 6,
        
        /// <summary>
        /// Status indicates that the rollback of migrated volume container is
        /// in progress
        /// </summary>
        RollbackInProgress = 7,
        
        /// <summary>
        /// Status indicates that the migrated volume container has
        /// successfully rolledback
        /// </summary>
        RollbackComplete = 8,
        
        /// <summary>
        /// Status indicates that the rollback of migrated volume container has
        /// failed
        /// </summary>
        RollbackFailed = 9,
    }
}
