// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.WebSites.Models;

namespace Microsoft.WindowsAzure.Management.WebSites.Models
{
    /// <summary>
    /// The List Web Hosting Plans operation response.
    /// </summary>
    public partial class WebHostingPlanListResponse : AzureOperationResponse, IEnumerable<WebHostingPlan>
    {
        private IList<WebHostingPlan> _webHostingPlans;
        
        /// <summary>
        /// Optional. The web spaces associated with the specified subscription.
        /// </summary>
        public IList<WebHostingPlan> WebHostingPlans
        {
            get { return this._webHostingPlans; }
            set { this._webHostingPlans = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WebHostingPlanListResponse class.
        /// </summary>
        public WebHostingPlanListResponse()
        {
            this.WebHostingPlans = new LazyList<WebHostingPlan>();
        }
        
        /// <summary>
        /// Gets the sequence of WebHostingPlans.
        /// </summary>
        public IEnumerator<WebHostingPlan> GetEnumerator()
        {
            return this.WebHostingPlans.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of WebHostingPlans.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
